/*
 * WeatherProxy.cpp
 *
 *  Created on: Sep 27, 2011
 *      Author: bdugan
 */

#include "WeatherProxy.h"

int WeatherProxy::getTemperature() {
  int messageCode = 0;
  int result;
  int bytesReceived;
  #define BYTEARRAYLENGTH 10000
  unsigned char byteArray[BYTEARRAYLENGTH];
  
  try {
    send(socket,&messageCode, sizeof(messageCode),0);
    
    bytesReceived = recv(socket,byteArray,BYTEARRAYLENGTH,0);
    ((unsigned char *) &result)[0] = byteArray[0];
    ((unsigned char *) &result)[1] = byteArray[1];
    ((unsigned char *) &result)[2] = byteArray[2];
    ((unsigned char *) &result)[3] = byteArray[3];
    
  } catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
  }
  
  return result;
}

string WeatherProxy::getSky() {
  int messageCode = 1;
  #define BYTEARRAYLENGTH 10000
  unsigned char byteArray[BYTEARRAYLENGTH];
  int bytesReceived;
  string result;

  try {
    send(socket,&messageCode, sizeof(messageCode),0);
    bytesReceived = recv(socket,byteArray,BYTEARRAYLENGTH,0);
    result.assign((char *) byteArray,strlen((char *) byteArray)+1);
  } catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
  }
  
  return result;
}

int WeatherProxy::getHumidty() {
  int messageCode = 2;
  int result;
  int bytesReceived;
  #define BYTEARRAYLENGTH 10000
  unsigned char byteArray[BYTEARRAYLENGTH];
   
  try {
    send(socket,&messageCode, sizeof(messageCode),0); 
    bytesReceived = recv(socket,byteArray,BYTEARRAYLENGTH,0);
   
    ((unsigned char *) &result)[0] = byteArray[0];
    ((unsigned char *) &result)[1] = byteArray[1];
    ((unsigned char *) &result)[2] = byteArray[2];
    ((unsigned char *) &result)[3] = byteArray[3];
    
  } catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
  }
  
  return result;
}

WeatherProxy::WeatherProxy() {
  
  try {
    ////////////////////////////////////////////////////////////////////
    // Create a socket.  
    ////////////////////////////////////////////////////////////////////  
    socket = ::socket(PF_INET,SOCK_STREAM,0);

    if (socket <= 0) {
      cerr << "clientr: Socket creation failed." << endl;
      exit(-1);
    }

    ////////////////////////////////////////////////////////////////////
    // Connect to server port
    ////////////////////////////////////////////////////////////////////
    sockaddr_in address;
    int addressSize = sizeof(sockaddr_in);
    address.sin_family=AF_INET;                         
    address.sin_port  = htons(15000); // <-------------------  port 15000
    inet_pton(AF_INET,"127.0.0.1",&address.sin_addr);  // <- IP 127.0.0.1 

    int status=0;
    status = connect(socket,(struct sockaddr*) &address, addressSize);

    if (status != 0) {
      cerr << "client:Connect failed, can't connect to port." << endl;
      cout << strerror(errno) << endl;
      exit(-1);
    }

    ////////////////////////////////////////////////////////////////////
    // Send/Receive messages until client types "/q"
    ////////////////////////////////////////////////////////////////////
    cout << "Server and client have established communication." << endl;
  } catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
  }
}

WeatherProxy::~WeatherProxy() {
  close(socket);
}
